



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>微信小程序函数调用监控</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">微信小程序函数调用监控</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 21:09:57 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>微信小程序之无埋点函数调用监控</h2>
<p>有时候，面对一个bug，左思右想就是无法理解为什么。</p>
<p>我就有过这样的经历，耗时整个一个晚上，后来还是放弃了。不得不在所有可能的点都加上日志，部署等待再次报错，真的很让人抓狂！</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1386816/201805/1386816-20180517105322820-286871858.jpg"></p>
<p>而实际上，解决一个bug的关键就是复现(reproduce)，真正解决bug也许就是改动一两个字符的事情。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1386816/201805/1386816-20180517105333308-1448553660.jpg"></p>
<p>因此，如果能够知道出错函数被调用的时候的参数值，以及整个函数调用链条，那么对于复现和理解这个bug，就相当有用了。</p>
<p>今天，给大家安利一个很不错的<a href="https://link.zhihu.com/?target=https%3A//docs.fundebug.com/notifier/wxjs/" rel="external nofollow noreferrer">Fundebug小程序bug监控插件</a>，它可以监控函数的调用以及记录函数参数值。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1386816/201805/1386816-20180517105345028-1212279750.png"></p>
<p>Fundebug提供网站、微信小程序和小游戏的bug监控服务。我看了一下，前端监控和游戏监控做得也不错，有机会可以试用一下。</p>
<p>微信小程序插件的接入和接入百度统计一样简单，在此我就不费口舌了。</p>
<p>值得注意的是，Fundebug的官方文档有写到：</p>
<blockquote><p>插件默认仅收集出错信息，保护隐私，收集systemInfo和userInfo需要开发者进行配置。</p></blockquote>
<p>同理，如果想要监控函数调用和记录函数参数值，需要手动配置。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1386816/201805/1386816-20180517105356873-533464532.png"></p>
<p>造个错看看效果，我在<code>getPhoneNumber</code>函数的第一行故意获取不存在的值：<br>候的调用函数<code>getPhoneNumber</code>和传入的参数。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1386816/201805/1386816-20180517105415731-558805241.png"></p>
<p>因为参数e的值中根本没有number，所以就容易理解出错的原因了。</p>
<h2>参考</h2>
<ul><ul><li><a href="https://link.zhihu.com/?target=https%3A//docs.fundebug.com/notifier/wxjs/" rel="external nofollow noreferrer">微信小程序-Fundebug文档</a></li>
<li><a href="https://link.zhihu.com/?target=https%3A//blog.fundebug.com/2018/04/10/fundebug-wxjs-0.1.2/" rel="external nofollow noreferrer">Fundebug：小程序错误监控支持用户行为回溯</a></li>
<li><a href="https://link.zhihu.com/?target=https%3A//www.softwaretestinghelp.com/bug-reporting-get-your-bugs-fixed/" rel="external nofollow noreferrer">The Art of Bug Reporting: How to Market and Get Your Bugs Fixed?</a></li>
<li><a href="https://link.zhihu.com/?target=https%3A//www.slideshare.net/usersnap/t3con15-the-best-dos-and-donts-of-a-bug-tracking-workflow" rel="external nofollow noreferrer">What do you do when you can't reproduce a defect?</a></li></ul></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvv74jq.html">尝试在你浏览器的Console&lpar;F12&rpar;中运行一下，你会发现页面被不同的颜色块高亮了（css调试中学到的js）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qygp32q.html">python函数动态参数详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnnkx0q.html">ORA-12705&colon; Cannot access NLS data files or invalid environment specified</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnkmld8.html">Prim求解最小生成树</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv25yxq.html">CentOS配置ssh无密码登录</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd11dm8.html">oracle&mdash;&mdash;DDL</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1yo2k8.html">Android权限安全&lpar;4&rpar;在什么时候检验权限&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y3d4jq.html">bzoj1453</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnro40q.html">cocos2dx中android下动态更新&period;so文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1lxv39.html">Maven3&period;0 服务器配置搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x6nj08.html">keil MDK编译器&lpar;V4&period;01&rpar;与H-JTAG的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z15gjx9.html">SQL Server 触发器的修改与删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meneyoq.html">重操JS旧业第七弹：面向对象与对象创建</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojd12xq.html">Openlayer 3 的画线测量长度</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1kwwmq.html">使用cobbler工具实现centos 6，7系统的自动化安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj13de9.html">python程序&mdash;利用socket监控端口</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvvp228.html">C&num;之WebApi权限认证&lowbar;学习笔记1</a>
		</li>
						<li><a href="https://www.batexi.com/a/960l45n9.html">Keil生成汇编文件、bin文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25vr73q.html">洛谷 P1337 &lbrack;JSOI2004&rsqb;平衡点 &sol; 吊打XXX 解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5xeg7q.html">java考试感受</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kpgjo79.html">【翻译】在Sencha Touch中创建离线&sol;在线代理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gev3378.html">TrueType字体的后缀名解释</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pw7oj8.html">CSS解决无空格太长的字母&comma;数字不会自动换行的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pw7ly8.html">mysql导入导出&period;sql数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pw56v8.html">hadoop任务监控页面namenode&colon;50030&lpar;在hadoop配置中查找集群jobtracker的ip，访问50030&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jlgyv8.html">React Native Android开发环境配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zy26g9.html">Java IO学习--&lpar;四&rpar;网络</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdo2579.html">Python中导入第三方声源库Acoular的逻辑解释以及Acoular的下载</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gevk3z8.html">redis主从，哨兵回忆手册</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me7zk2q.html">JavaScript中高阶函数</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
